## Soul - Magento 2 Gulp Build Workflow

Soul is a Magento 2 gulp build process to allow for better sass, js and image workflow.

### Components

- Sass
- Sass Lint
- JS
- JS esLint
- Image & SVG compression

### How Do I Setup?

Luckily, it's super simple!
1. Make sure that you have this in your composer.json file - it will let you have access to download modules from the Pinpoint repo:
```
    "pinpoint": {
    	"type": "composer",
    	"url": "https://packages.pinpointdesigns.co.uk/"
    }
```
2. Make sure I'm in your composer file by running `composer require pinpoint/soul 0.1.0`. Make sure you're running at least PHP7.1 with composer and adjust as needed (i.e. `comp71 require pinpoint/soul`). Also, you'll see the version number in the `require`, please make sure you're getting the latest version that has been tagged [in the repository](https://github.com/PinpointDesigns/Soul/releases).
   **NOTE:** This will update any modules that are **not locked** to a version number. Please make sure that 3rd party modules have a fixed version number against them to avoid breaking anything else.
3. Once this has been grabbed and installed, you can go to `[site root]/vendor/pinpoint/soul` and run the command `npm install` to get all the dependencies.

### Per Site Configuration
Post setup, you'll now have a few files in `dev/tools/soul`

`themes.json`
This is where you tell me about your themes. You only need to tell me a few things about your themes:
```
{
	"base": {
		"src": "app/design/frontend/Pinpoint/Spirit",
		"dest": "pub/static/frontend/Pinpoint/Spirit",
		"locale": ["en_GB"]
	}
}
```
The first level in the `json` is the name of your theme.
`src` is where your theme will be - probably in `app/design/frontend`.
`dest` is where your theme will be going when compiled - usually `pub/static/frontend`.
`locale` is the language locales within Magento your theme will be compiled for.
`parent` is only used if it is a child theme.

`gulp`
This will run through all the inheritance for the themes within your site and compile the Sass in to a useable css file.
